<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmModoDeDivulgacaoService;

class CrmModoDeDivulgacaoController {

    protected $CrmModoDeDivulgacaoService;

    use TResponse;

    public function __construct(CrmModoDeDivulgacaoService $CrmModoDeDivulgacaoService)
    {
        $this->CrmModoDeDivulgacaoService = $CrmModoDeDivulgacaoService;
    }

    public function getDisclosureMode (){
        try {
            $data = $this->CrmModoDeDivulgacaoService->getDisclosureModeService();
            $this->sendResponse($data, 200);
        } catch (\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function saveNewDisclosureMode(Request $request){
        try {
            
            $data = $this->CrmModoDeDivulgacaoService->saveNewDisclosureModeService($request->getParameters());

        } catch (\Exception $e) {

            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);

        }
    }

    public function deleteDisclosureMode (Request $request) {
        try {
            $this->CrmModoDeDivulgacaoService->deleteDisclosureModeService($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}