<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmTermometroDeOportunidadeService;

class CrmTermometroDeOportunidadeController
{
    protected $CrmTermometroDeOportunidadeService;

    use TResponse;

    public function __construct(CrmTermometroDeOportunidadeService $CrmTermometroDeOportunidadeService)
    {
        $this->CrmTermometroDeOportunidadeService = $CrmTermometroDeOportunidadeService;
    }

    public function getOpportunityThermometer()
    {
        try {
            $data = $this->CrmTermometroDeOportunidadeService->getOpportunityThermometer();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    public function getFieldColor()
    {
        try {
            $data = $this->CrmTermometroDeOportunidadeService->getFieldColor();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


    public function saveThermometerOpportunity(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->CrmTermometroDeOportunidadeService->saveThermometerOpportunity($rows);
        } catch (\Exception $e) {

            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
        }
    }

    public function deleteThermometerOpportunity(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->CrmTermometroDeOportunidadeService->deleteThermometerOpportunity($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
