CREATE OR REPLACE
PROCEDURE INSERE_ATIVIDADE
  (P_CDFILIAL IN SOLISERV.CDFILIAL%TYPE,
   P_NRSOLISERV IN SOLISERV.NRSOLISERV%TYPE,
   P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,
   P_CDASSUNTO IN SOLISERV.CDASSUNTO%TYPE)
AS
   V_NRTAREFA NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_DSREFETAREFA SOLISERV.DSREFESOLI%TYPE;
   V_CDASSUNTO SOLISERV.CDASSUNTO%TYPE;
   V_CDCLIENTE SOLISERV.CDCLIENTE%TYPE;
   V_CDPRODCOMP SOLISERV.CDPRODCOMP%TYPE;
   V_NRPLATIVTARE NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_CDPROJETO PROJETO.CDPROJETO%TYPE;
   V_CDPROCESSO PROCESSO.CDPROCESSO%TYPE;
   V_CDITEMTRAB ITEMTRAB.CDITEMTRAB%TYPE;
   V_NRTARESOLI TAREFA.NRTAREFA%TYPE;
   V_TEMPOMIN PROCESSO.QTTEMPMINATIV%TYPE;
   V_VRPRODMEDES PROCESSO.VRPRODMEDES%TYPE;
   V_PONTO PLANATIVTARE.NRCPLXPLANAT%TYPE;
BEGIN
   USR_NOVO_CODIGO('TAREFA'||P_CDFILIAL, V_NRTAREFA);
   V_NRTAREFA := SUBSTR(V_NRTAREFA,11,10);
   SELECT DSREFESOLI, CDASSUNTO, CDCLIENTE, CDPRODCOMP
     INTO V_DSREFETAREFA, V_CDASSUNTO, V_CDCLIENTE, V_CDPRODCOMP
     FROM SOLISERV
    WHERE CDFILIAL = P_CDFILIAL
      AND NRSOLISERV = P_NRSOLISERV;
   V_CDPROJETO := PROJETO_POR_SISTEMA(V_CDPRODCOMP, V_CDASSUNTO);
   SELECT MIN(NRTAREFA)
     INTO V_NRTARESOLI
     FROM TAREFA
    WHERE CDFILIAL = P_CDFILIAL
      AND NRSOLISERV = P_NRSOLISERV;
   IF V_CDPROJETO IS NOT NULL THEN
      IF V_NRTARESOLI IS NULL THEN
         INSERT INTO SOLIBASELINE
            (CDFILIAL, CDPROJETO, NRBASELINEPR, NRSOLISERV,DTINSOLBASELIPR,CDOPINSOLBASELI,IDSITUSOLBASELI)
         VALUES
            (P_CDFILIAL, V_CDPROJETO, '001', P_NRSOLISERV,SYSDATE,P_CDOPERADOR,'I');
         INSERT INTO TAREFA
            (CDFILIAL, NRTAREFA, DSREFETAREFA, CDASSUNTO, CDCLIENTE, CDOPERRESP,
             CDOPERABER, DTABERTAREFA, IDSITTAREFA, IDORIGTARE, NRSOLISERV)
         VALUES
            (P_CDFILIAL, V_NRTAREFA, V_DSREFETAREFA, V_CDASSUNTO, V_CDCLIENTE, P_CDOPERADOR,
             P_CDOPERADOR, SYSDATE, 'P', '1', P_NRSOLISERV);
         IF P_CDASSUNTO IN ('00010', /* ERRO LEVE - MANUTENO */
                            '00011', /* ERRO GRAVE - MANUTENO */
                            '00102', /* ERRO EM SISTEMA - SUPORTE */
                            '00016', /* PERFORMANCE - MANUTENO */
                            '00104') THEN /* PERFORMANCE */
            V_CDPROCESSO := '0000011058';
            V_CDITEMTRAB := '0000009386';
         ELSE
            V_CDPROCESSO := '0000010171';
            V_CDITEMTRAB := '0000009441';
         END IF;
         IF P_CDASSUNTO = ('02010') THEN  /* GERNCIA DE PRODUTO */
            V_CDPROCESSO := '0000011490'; /* 60.1.0001.01 GERNCIA DE PRODUTO */ 
            V_CDITEMTRAB := '0000013397'; /* 5.1.010.GERENCIAPROD */ 
         END IF;

         USR_NOVO_CODIGO('PLANATIVTARE'||P_CDFILIAL||V_NRTAREFA, V_NRPLATIVTARE);
         V_NRPLATIVTARE := SUBSTR(V_NRPLATIVTARE, 16, 20);
         SELECT NVL(MAX(QTTEMPMINATIV), 0), NVL(MAX(VRPRODMEDES), 0)
           INTO V_TEMPOMIN, V_VRPRODMEDES
           FROM PROCESSO
          WHERE CDPROCESSO = V_CDPROCESSO;
         V_PONTO := ROUND(V_TEMPOMIN * V_VRPRODMEDES,2);
         INSERT INTO ITEMTAREFA
            (CDFILIAL, NRTAREFA, NRSEQUITTARE, DSREFEITTARE, DTINCLITTARE, CDOPERADOR, CDOPERRESP, CDITEMTRAB)
         VALUES
            (P_CDFILIAL, V_NRTAREFA, '0000000001', V_DSREFETAREFA, SYSDATE, P_CDOPERADOR, P_CDOPERADOR, V_CDITEMTRAB);
         INSERT INTO PLANATIVTARE
            (CDFILIAL, NRTAREFA, NRPLATIVTARE, CDPROCESSO, CDOPERRESP, IDSITATIVTAR, DTINCATIVTAR,
             CDOPERINCL, CDITEMTRAB, QTTEMPLAITAR, NRCPLXPLANAT, NRCPLXITATIV)
         VALUES
            (P_CDFILIAL, V_NRTAREFA, V_NRPLATIVTARE, V_CDPROCESSO, P_CDOPERADOR, 'P', SYSDATE,
             P_CDOPERADOR, V_CDITEMTRAB, V_TEMPOMIN, V_PONTO, V_PONTO);
         INSERT INTO PLATVRELITTR
            (CDFILIAL, NRTAREFA, NRPLATIVTARE, NRSEQUITTARE)
         VALUES
            (P_CDFILIAL, V_NRTAREFA, V_NRPLATIVTARE, '0000000001');
      ELSE
         IF P_CDASSUNTO IN ('00010', /* ERRO LEVE - MANUTENO */
                            '00011', /* ERRO GRAVE - MANUTENO */
                            '00102', /* ERRO EM SISTEMA - SUPORTE */
                            '00016', /* PERFORMANCE - MANUTENO */
                            '00104') THEN /* PERFORMANCE */
            V_CDPROCESSO := '0000011058';
            V_CDITEMTRAB := '0000009386';
         ELSE
            V_CDPROCESSO := '0000010171';
            V_CDITEMTRAB := '0000009441';
         END IF;
         IF V_CDITEMTRAB IS NOT NULL THEN
            UPDATE PLANATIVTARE
               SET CDOPERRESP = P_CDOPERADOR
             WHERE CDFILIAL = P_CDFILIAL
               AND NRTAREFA = V_NRTARESOLI
               AND CDPROCESSO = V_CDPROCESSO
               AND CDITEMTRAB = V_CDITEMTRAB
               AND IDSITATIVTAR = 'P';
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INSERE_ATIVIDADE','5.11.001'); END;
/








































