import { Select } from '@zeedhi/common';
import { IEventParam, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class CrmEnderecoController {
  public changeEstado({ component }: IEventParam<Select>) {
    const sgestado = Metadata.getInstance<Select>('SGESTADO');

    if (component.value) {
      sgestado.datasource.setFilter({
        CDPAIS: component.selectValue.CDPAIS,
      });
    }
  }

  public changeMunicipio({ component }: IEventParam<Select>) {
    const nmmunicipio = Metadata.getInstance<Select>('NMMUNICIPIO');
    const nmmbairro = Metadata.getInstance<Select>('NMBAIRRO');
    if (component.value) {
      nmmunicipio.datasource.setFilter({
        SGESTADO: component.selectValue.SGESTADO,
      });
      nmmbairro.datasource.setFilter({
        SGESTADO: component.selectValue.SGESTADO,
      });
    }
  }

  public changeEstadoModal({ component }: IEventParam<Select>) {
    const sgestadoModal = Metadata.getInstance<Select>('MODAL_SGESTADO');

    if (component.value) {
      sgestadoModal.datasource.setFilter({
        CDPAIS: component.selectValue.CDPAIS,
      });
    }
  }

  public changeMunicipioModal({ component }: IEventParam<Select>) {
    const nmmunicipioModal = Metadata.getInstance<Select>('MODAL_NMMUNICIPIO');
    const nmmbairroModal = Metadata.getInstance<Select>('MODAL_NMBAIRRO');
    if (component.value) {
      nmmunicipioModal.datasource.setFilter({
        SGESTADO: component.selectValue.SGESTADO,
      });
      nmmbairroModal.datasource.setFilter({
        SGESTADO: component.selectValue.SGESTADO,
      });
    }
  }

  public changeEstadoFilter({ component }: IEventParam<Select>) {
    const componentGrid = Metadata.getInstance<TekGrid>('tek-grid-crm_concorrente-grid');
    const sgestado = componentGrid.modalFilterProps;

    if (component.value) {
      sgestado.datasource.setFilter({
        CDPAIS: component.selectValue.CDPAIS,
      });
    }
  }

  public changeMunicipioFilter({ component }: IEventParam<Select>) {
    const nmmunicipio = Metadata.getInstance<Select>('NMMUNICIPIO');
    const nmmbairro = Metadata.getInstance<Select>('NMBAIRRO');
    if (component.value) {
      nmmunicipio.datasource.setFilter({
        SGESTADO: component.selectValue.SGESTADO,
      });
      nmmbairro.datasource.setFilter({
        SGESTADO: component.selectValue.SGESTADO,
      });
    }
  }
}
